/*
 File: term_def_phsym.cpp
 Date and Time: Fri Jan 30 18:55:26 2015 
*/
#include "term_def_ph.h"
using namespace NS_yacco2_T_enum;// enumerate
using namespace NS_yacco2_err_symbols;// error symbols
using namespace NS_yacco2_k_symbols;// lrk 
using namespace NS_yacco2_terminals;// terminals
using namespace NS_yacco2_characters;// rc 
using namespace yacco2;// yacco2 library
using namespace NS_term_def_ph;// grammar's ns
// first set terminals
yacco2::THR _YACCO2_CALL_TYPE
NS_term_def_ph::TH_term_def_ph(yacco2::Parser* Caller_pp){
  yacco2::Thread_entry& pp_thread_entry = ITH_term_def_ph;
  NS_term_def_ph::Cterm_def_ph Cterm_def_ph_;// parallel-parser's parse table
#define ssPARSE_TABLE Cterm_def_ph_
#include "wpp_core.h"
}
THR_result _YACCO2_CALL_TYPE
NS_term_def_ph::PROC_TH_term_def_ph(yacco2::Parser* Caller_pp){
  char called_proc_name[] = "PROC_TH_term_def_ph";
  static bool one_time(false);
  static NS_term_def_ph::Cterm_def_ph* NS_term_def_ph_Cterm_def_ph_(0);// parallel-parser's fsm table
  static Parser* NS_term_def_ph_Cterm_def_ph_parser(0);
  Parser* proc_parser(0);
  if(one_time == false){
    one_time = true;
    NS_term_def_ph_Cterm_def_ph_ = new NS_term_def_ph::Cterm_def_ph();// parallel-parser's fsm table
    NS_term_def_ph_Cterm_def_ph_parser = new Parser(*NS_term_def_ph_Cterm_def_ph_,Caller_pp);
  }
 proc_parser = NS_term_def_ph_Cterm_def_ph_parser;
#include "wproc_pp_core.h"
}
void 
Cterm_def_ph::reduce_rhs_of_rule
    (yacco2::UINT Sub_rule_no,yacco2::Rule_s_reuse_entry** Recycled_rule){
   int reducing_rule = rhs_to_rules_mapping_[Sub_rule_no];
   Per_rule_s_reuse_table* rule_reuse_tbl_ptr = 
        fsm_rules_reuse_table.per_rule_s_table_[reducing_rule];
   Rule_s_reuse_entry* re(0);
   find_a_recycled_rule(rule_reuse_tbl_ptr,&re);
   (*Recycled_rule) = re;
   fnd_re: switch (Sub_rule_no){
    case rhs1_Rterminal_def_phrase_:{
       Rterminal_def_phrase* sym;
     if(re->rule_ == 0){
       sym = new Rterminal_def_phrase(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rterminal_def_phrase*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 14;
    

     sym->sr1();
     return;}
    case rhs1_Rid_:{
       Rid* sym;
     if(re->rule_ == 0){
       sym = new Rid(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rid*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr1();
     return;}
    case rhs2_Rid_:{
       Rid* sym;
     if(re->rule_ == 0){
       sym = new Rid(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rid*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr2();
     return;}
    case rhs3_Rid_:{
       Rid* sym;
     if(re->rule_ == 0){
       sym = new Rid(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rid*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr3();
     return;}
    case rhs4_Rid_:{
       Rid* sym;
     if(re->rule_ == 0){
       sym = new Rid(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rid*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr4();
     return;}
    case rhs5_Rid_:{
       Rid* sym;
     if(re->rule_ == 0){
       sym = new Rid(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rid*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr5();
     return;}
    case rhs6_Rid_:{
       Rid* sym;
     if(re->rule_ == 0){
       sym = new Rid(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rid*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr6();
     return;}
    case rhs7_Rid_:{
       Rid* sym;
     if(re->rule_ == 0){
       sym = new Rid(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rid*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr7();
     return;}
    case rhs1_Rad_ab_tags_:{
       Rad_ab_tags* sym;
     if(re->rule_ == 0){
       sym = new Rad_ab_tags(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rad_ab_tags*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     return;}
    case rhs2_Rad_ab_tags_:{
       Rad_ab_tags* sym;
     if(re->rule_ == 0){
       sym = new Rad_ab_tags(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rad_ab_tags*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 3;
    

     return;}
    case rhs3_Rad_ab_tags_:{
       Rad_ab_tags* sym;
     if(re->rule_ == 0){
       sym = new Rad_ab_tags(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rad_ab_tags*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 0;
    

     return;}
    case rhs1_Rad_ab_tag_:{
       Rad_ab_tag* sym;
     if(re->rule_ == 0){
       sym = new Rad_ab_tag(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rad_ab_tag*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr1();
     return;}
    case rhs2_Rad_ab_tag_:{
       Rad_ab_tag* sym;
     if(re->rule_ == 0){
       sym = new Rad_ab_tag(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rad_ab_tag*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr2();
     return;}
    case rhs1_Rsym_cweb_k_:{
       Rsym_cweb_k* sym;
     if(re->rule_ == 0){
       sym = new Rsym_cweb_k(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rsym_cweb_k*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 0;
    

     return;}
    case rhs2_Rsym_cweb_k_:{
       Rsym_cweb_k* sym;
     if(re->rule_ == 0){
       sym = new Rsym_cweb_k(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rsym_cweb_k*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr2();
     return;}
    case rhs3_Rsym_cweb_k_:{
       Rsym_cweb_k* sym;
     if(re->rule_ == 0){
       sym = new Rsym_cweb_k(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rsym_cweb_k*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr3();
     return;}
    case rhs1_Rsym_class_phrase_:{
       Rsym_class_phrase* sym;
     if(re->rule_ == 0){
       sym = new Rsym_class_phrase(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rsym_class_phrase*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 3;
    

     return;}
    case rhs1_Rsym_class_:{
       Rsym_class* sym;
     if(re->rule_ == 0){
       sym = new Rsym_class(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rsym_class*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     return;}
    case rhs2_Rsym_class_:{
       Rsym_class* sym;
     if(re->rule_ == 0){
       sym = new Rsym_class(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rsym_class*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->sr2();
     return;}
    case rhs1_Rsym_class_id_:{
       Rsym_class_id* sym;
     if(re->rule_ == 0){
       sym = new Rsym_class_id(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rsym_class_id*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr1();
     return;}
    case rhs2_Rsym_class_id_:{
       Rsym_class_id* sym;
     if(re->rule_ == 0){
       sym = new Rsym_class_id(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rsym_class_id*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr2();
     return;}
    case rhs3_Rsym_class_id_:{
       Rsym_class_id* sym;
     if(re->rule_ == 0){
       sym = new Rsym_class_id(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rsym_class_id*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->sr3();
     return;}
    case rhs1_Rpotential_code_blk_:{
       Rpotential_code_blk* sym;
     if(re->rule_ == 0){
       sym = new Rpotential_code_blk(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rpotential_code_blk*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 0;
    

     return;}
    case rhs2_Rpotential_code_blk_:{
       Rpotential_code_blk* sym;
     if(re->rule_ == 0){
       sym = new Rpotential_code_blk(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rpotential_code_blk*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 6;
    

     return;}
    case rhs1_Ropen_par_:{
       Ropen_par* sym;
     if(re->rule_ == 0){
       sym = new Ropen_par(parser__);
       re->rule_ = sym;
     }else{
       sym = (Ropen_par*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->sr1();
     return;}
    case rhs2_Ropen_par_:{
       Ropen_par* sym;
     if(re->rule_ == 0){
       sym = new Ropen_par(parser__);
       re->rule_ = sym;
     }else{
       sym = (Ropen_par*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     return;}
    case rhs1_Rclose_par_:{
       Rclose_par* sym;
     if(re->rule_ == 0){
       sym = new Rclose_par(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rclose_par*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->sr1();
     return;}
    case rhs2_Rclose_par_:{
       Rclose_par* sym;
     if(re->rule_ == 0){
       sym = new Rclose_par(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rclose_par*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     return;}
    case rhs1_Rclosing_brace_:{
       Rclosing_brace* sym;
     if(re->rule_ == 0){
       sym = new Rclosing_brace(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rclosing_brace*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->sr1();
     return;}
    case rhs2_Rclosing_brace_:{
       Rclosing_brace* sym;
     if(re->rule_ == 0){
       sym = new Rclosing_brace(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rclosing_brace*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     return;}
    case rhs1_Rdirectives_:{
       Rdirectives* sym;
     if(re->rule_ == 0){
       sym = new Rdirectives(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rdirectives*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 3;
    

     sym->sr1();
     return;}
    case rhs2_Rdirectives_:{
       Rdirectives* sym;
     if(re->rule_ == 0){
       sym = new Rdirectives(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rdirectives*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 4;
    

     sym->sr2();
     return;}
    case rhs1_Rdirective_:{
       Rdirective* sym;
     if(re->rule_ == 0){
       sym = new Rdirective(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rdirective*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr1();
     sym->op();
     return;}
    case rhs2_Rdirective_:{
       Rdirective* sym;
     if(re->rule_ == 0){
       sym = new Rdirective(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rdirective*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr2();
     sym->op();
     return;}
    case rhs3_Rdirective_:{
       Rdirective* sym;
     if(re->rule_ == 0){
       sym = new Rdirective(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rdirective*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr3();
     sym->op();
     return;}
    case rhs4_Rdirective_:{
       Rdirective* sym;
     if(re->rule_ == 0){
       sym = new Rdirective(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rdirective*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr4();
     sym->op();
     return;}
    case rhs5_Rdirective_:{
       Rdirective* sym;
     if(re->rule_ == 0){
       sym = new Rdirective(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rdirective*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr5();
     sym->op();
     return;}
    case rhs6_Rdirective_:{
       Rdirective* sym;
     if(re->rule_ == 0){
       sym = new Rdirective(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rdirective*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr6();
     sym->op();
     return;}
    case rhs1_Rsyntax_code_:{
       Rsyntax_code* sym;
     if(re->rule_ == 0){
       sym = new Rsyntax_code(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rsyntax_code*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr1();
     return;}
    case rhs2_Rsyntax_code_:{
       Rsyntax_code* sym;
     if(re->rule_ == 0){
       sym = new Rsyntax_code(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rsyntax_code*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr2();
     return;}
    case rhs1_Rlint_:{
       Rlint* sym;
     if(re->rule_ == 0){
       sym = new Rlint(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rlint*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     return;}
    case rhs2_Rlint_:{
       Rlint* sym;
     if(re->rule_ == 0){
       sym = new Rlint(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rlint*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 0;
    

     return;}
    default: return;
   }
}
